;TELL program by Howard Moulton - Milford RCPM
;1-617-478-3693 voice
;1-617-478-4164 RCPM
;This is a small utility used to find out various
;locations of what and where various addresses are
;within the CP/M for which this utility operates.
;Quite useful if your writing software for CP/M,
;but need to find out the EXACT addresses that some
;CBOIS routines are operating when the occasion
;arises that the software CAN'T access it thru
;CP/M, like rewriting FORMAT programs and such
;utilities as those.....
;Any mods or changes or enhancements would be
;appreciated......Howard
;
;
BDOS	EQU	5
PRINT	EQU	9
RDCON	EQU	1
WRCON	EQU	2
RESET	EQU	13
SELDS	EQU	14
SEAFF	EQU	17
SEANF	EQU	18
RESEC	EQU	20
;
;
	ORG	0100H
	LXI	D,INTRO
	MVI	C,PRINT
	CALL	BDOS
	CALL	CRLF
	JMP	START
INTRO DB 13,10,'This is a utility that tells you where'
 DB 13,10,'your CCP starts, what your BDOS entry add-'
 DB 13,10,'ress is, and where your CBIOS jump table'
 DB 13,10,'begins, as well as other useful info.'
 DB 13,10,'$'
;
;WE'LL USE CPM'S STACK SEEIN WE'RE SO SMALL, WE
;COULDN'T POSSIBLY OVERWRITE THE CCP, WHICH
;WOULD REQUIRE A WARM START....
START	LHLD	1	;GET WBOOT ADDR
	DCX	H
	DCX	H
	DCX	H	;BUMP DOWN TO CBOOT ADDR.
;NOW STORE THE AQUIRED BEGINNING OF THE JUMP TABLE
	SHLD	JMPTBL
;NOW GET THE CCP ADDRESS....
	MOV	A,H	;GET HI ADDR
	SUI	16H	;SUBTRACT 1600H
	MOV	H,A
	SHLD	CCPADD	;NOW GOT CCP ADDRESS
;NOW GET THE BDOS ENTRY ADDRESS...
	LXI	D,806H	;GET OFFSET FOR BDOS ENTRY
	DAD	D
	SHLD	DOSENT	;NOW HAS BDOS ENTRY POINT
;NOW TELL THEM SOMETHING ABOUT THE ENVIRONMENT
;WE HAVE FOUND...
;FIRST, TELL WHERE CCP IS...
	LXI	D,CCPMSG
	MVI	C,PRINT
	CALL	BDOS
	LHLD	CCPADD	;GET CCP
	CALL	SWAP	;SWAP THEM FOR NOW
	CALL	SNDH
;NOW FOR THE BDOS ENTRY ADDRESS....
	LXI	D,DOSMSG ;POINT TO MESSAGE
	MVI	C,PRINT	;AND PRINT...
	CALL	BDOS	;IT OUT..
	LHLD	DOSENT	;GET DOS ENTRY ADD IN H
	CALL	SWAP	;SWAP THEM FOR NOW
	CALL	SNDH
;NOW FOR THE JUMP TABLE...
	LXI	D,JMPMSG
	MVI	C,PRINT
	CALL	BDOS
	LHLD	JMPTBL
	CALL	SWAP
	CALL	SNDH
;LIST JUMP TABLE NOW...
;GIVE ADDRESS OF COLD START
	LXI	D,J0
	MVI	C,PRINT
	CALL	BDOS
	JMP	N0
J0 DB 'Cold start routine:',9,9,9,'$'
N0	LXI	D,0	;NO OFFSET
	CALL	SETUP
	CALL	SNDH
;NEXT IN JUMP TABLE...
	LXI	D,J1	;START LISTING JMP TABLE
	MVI	C,PRINT
	CALL	BDOS
	JMP	N1
J1 DB 'Warmstart routine:',9,9,9,'$'
N1	LXI	D,3
	CALL	SETUP
	CALL	SNDH
;NOW THE REST...
	LXI	D,J2
	MVI	C,PRINT
	CALL	BDOS
	JMP	N2
J2 DB 'Console status routine:',9,9,9,'$'
N2	LXI	D,6
	CALL	SETUP
	CALL	SNDH
;THE CONSOLE IN ROUTINE
	LXI	D,J3
	MVI	C,PRINT
	CALL	BDOS
	JMP	N3
J3 DB 'Console Input routine (waits for char.):$'
N3	LXI	D,9
	CALL	SETUP
	CALL	SNDH
;CONSOLE OUT ROUTINE...
	LXI	D,J4
	MVI	C,PRINT
	CALL	BDOS
	JMP	N4
J4 DB 'Console out routine:',9,9,9,'$'
N4	LXI	D,0CH
	CALL	SETUP
	CALL	SNDH
;NOW THE LIST DEVICE...
	LXI	D,J5
	MVI	C,PRINT
	CALL	BDOS
	JMP	N5
J5 DB 'List device out routine:',9,9,'$'
N5	LXI	D,0FH
	CALL	SETUP
	CALL	SNDH
;NEXT JMP...
	LXI	D,J6
	MVI	C,PRINT
	CALL	BDOS
	JMP	N6
J6 DB 'Punch out routine:',9,9,9,'$'
N6	LXI	D,12H
	CALL	SETUP
	CALL	SNDH
;NOW THE READER..
	LXI	D,J7
	MVI	C,PRINT
	CALL	BDOS
	JMP	N7
J7 DB 'Reader in routine:',9,9,9,'$'
N7	LXI	D,15H
	CALL	SETUP
	CALL	SNDH
;NOW THE HOME DISK
	LXI	D,J8
	MVI	C,PRINT
	CALL	BDOS
	JMP	N8
J8 DB 'Home disk routine:',9,9,9,'$'
N8	LXI	D,18H
	CALL	SETUP
	CALL	SNDH
;SELECT DISK ROUTINE
	LXI	D,J9
	MVI	C,PRINT
	CALL	BDOS
	JMP	N9
J9 DB 'Select disk routine:',9,9,9,'$'
N9	LXI	D,1BH
	CALL	SETUP
	CALL	SNDH
;SET TRACK ROUTINE...
	LXI	D,J10
	MVI	C,PRINT
	CALL	BDOS
	JMP	N10
J10 DB 'The set track routine:',9,9,9,'$'
N10	LXI	D,1EH
	CALL	SETUP
	CALL	SNDH
;SET SEC...
	LXI	D,J11
	MVI	C,PRINT
	CALL	BDOS
	JMP	N11
J11 DB 'Set the sector routine:',9,9,9,'$'
N11	LXI	D,21H
	CALL	SETUP
	CALL	SNDH
;THE DMA
	LXI	D,J12
	MVI	C,PRINT
	CALL	BDOS
	JMP	N12
J12 DB 'Set the dma routine:',9,9,9,'$'
N12	LXI	D,24H
	CALL	SETUP
	CALL	SNDH
;READ THE DISK
	LXI	D,J13
	MVI	C,PRINT
	CALL	BDOS
	JMP	N13
J13 DB 'Read disk routine:',9,9,9,'$'
N13	LXI	D,27H
	CALL	SETUP
	CALL	SNDH
;WRITE DISK ....
	LXI	D,J14
	MVI	C,PRINT
	CALL	BDOS
	JMP	N14
J14 DB 'Write disk routine:',9,9,9,'$'
N14	LXI	D,2AH
	CALL	SETUP
	CALL	SNDH
;LIST STATUS
	LXI	D,J15
	MVI	C,PRINT
	CALL	BDOS
	JMP	N15
J15 DB 'List status routine:',9,9,9,'$'
N15	LXI	D,2DH
	CALL	SETUP
	CALL	SNDH
;SECTOR TRANSLATE
	LXI	D,J16
	MVI	C,PRINT
	CALL	BDOS
	JMP	N16
J16 DB 'Sector translate routine:',9,9,'$'
N16	LXI	D,30H
	CALL	SETUP
	CALL	SNDH
;
	RET		;POP OFF TO CPM
;
;SETUP DOES SETUP OF NEW ADDRESS - D+E = OFFSET
;FROM LOCATION JMPTBL, WHICH GETS INTO HL FROM HERE
SETUP	LHLD	JMPTBL
	DAD	D
	INX	H
	MOV	D,M
	INX	H
	MOV	E,M
	XCHG
	SHLD	TMPADR
	RET
;
;SENDS ADDR IN ASCII TO CON
SNDH	LXI	D,TMPADR
	MVI	C,2
	CALL	CONV
	RET
;ROUTINE TO CONVERT BINARY TO ASCII
;Enters with d+e pointing to the byte or word to
;convert and the count in c...
CONV	LDAX	D
	PUSH	D	;SAVE THE ENTRY ADD
	PUSH	B
	PUSH	PSW	;SAVE THE LOWER HALF
	CALL	BINH
	POP	PSW	;GET LOWER HALF BACK
	CALL	BINL
	POP	B	;GET BACK COUNT
	POP	D	;GET BACK POINT
	DCR	C
	JZ	HEX	;JMP IF NO MORE TO "HEX"
	INX	D	;MOV D UP ONE
	JMP	CONV
BINH	RAR ! RAR ! RAR ! RAR
BINL	ANI	15
	ADI	48
	CPI	58
	JC	AOUT
	ADI	7
AOUT	MOV	E,A
	MVI	C,WRCON
	CALL	BDOS
	RET
HEX	MVI	E,'H'	;GET H IN E
	MVI	C,WRCON
	CALL	BDOS
	MVI	E,'.'
	MVI	C,WRCON
	CALL	BDOS
;FALL INTO CRLF AND RET
;
;SEND CARRAGE + LF TO CON
CRLF	MVI	E,10
	MVI	C,WRCON
	CALL	BDOS
	MVI	E,13
	MVI	C,WRCON
	CALL	BDOS
	RET
;
;
;SWAP ROUTINE - SWAPS WHAT IS IN HL AND STORES @ TMPADR
SWAP	MOV	E,H
	MOV	D,L
	XCHG		;SWAP 'EM
	SHLD	TMPADR
	RET
;
CCPMSG DB 'Your CCP starts at:',9,9,9,'$'
CCPADD DW 0
DOSMSG DB 'Your BDOS entry address is:',9,9,'$'
DOSENT DW 0
JMPMSG DB 'Your CBIOS jump table begins at:',9,'$'
JMPTBL DW 0
TMPADR DW 0
ur BDOS entry address is:',9,9,'$'