@string(head="Read Me First")
@pageheading(left="@value{head}", right="Read Me First")
@center(@b[SETTING UP YOUR KAYPRO II/PERFECT SOFTWARE DISKETTES])

	Welcome to the exciting world of personal computing. 
Your powerful Kaypro II computer and Perfect Software are
bringing to you a new era of productivity, creativity and
efficiency. 


	Your Kaypro II computer comes with four integrated
software packages: @i{Perfect Writer, Perfect Speller, Perfect
Filer, and Perfect Calc}.  These programs represent the @i(state
of the art) in high quality personal computer software.  They
provide you with capabilities found nowhere else.  The programs
all use the same command structure, so that learning one means
that you are familiar with all.  Although you may not be using
the full power of your Kaypro II computer and Perfect
Software when you first begin, you will be surprised at how
quickly you will learn all of the outstanding capabilities of this
fine computer and these remarkable software programs.


	 All of the Perfect Software programs come to you set up and
ready to run on your Kaypro II computer, which is to say the
programs have been properly 'configured' for the Kaypro II. Although
installation programs have been included for Perfect Writer
and Perfect Calc  (in the event that  you wish to customize these
programs to suit your particular needs),  you will probably never
need to use them.

	The only thing that you must do before beginning to use
the programs is to make several slight  changes in the groupings
of the program files.  For technical reasons, and for reasons of
economy and space, several program files have been included
together on the same diskette.  You should move them to separate
diskettes before beginning.  The purpose  of this pamphlet is to
explain how this should be done.
@newpage


@center[@b{'BACKING-UP' THE DISTRIBUTION DISKETTES}]

	@b(The first step) you must take before continuing with
the remaining procedures in this pamphlet  @b(is to make
'back-up' copies of your Perfect Software distribution
diskettes.)  Do this using the 'COPY' procedure described in your
Kaypro II User's Guide (also in the disk-based lesson
'B:KAYPRO.LRN' on your Perfect Writer Lessons Diskette).  Under
@i(no circumstances) should you attempt to use these original
diskettes as everyday 'working' copies.  With continued use
diskettes will wear out and become faulty.  Don't let this happen
to the only program diskettes that you have.
	
	Once you have copied your master distribution diskettes,
store them in a @i(safe place). Only take them out when you have to
make an occasional 'new' working copy.

	@b(IMPORTANT:  The remaining procedures outlined in the
pamphlet should be performed using the 'back-up' diskettes only!)
@string(head="Perfect Writer")
@newpage


@heading{@b[PERFECT WRITER]}

@i(Perfect Writer) comes to you on three diskettes:

@flushleft(@b<1. Edit Diskette>)

	The Edit diskette contains the Perfect Writer word
processing programs which allow you to edit and print documents. 
The program files on this diskette are as follows:

@begin(description)
@B(pw.swp)@/A file containing 'virtual memory' space as well as
certain technical data about your Kaypro II computer which
Perfect Writer needs to function properly. (@b[P]erfect
@b[W]riter@b[.SW]a@b[P])

@B(menu.com)@/The menu program which will guide you in using
Perfect Writer. (@b[MENU.COM]piled)

@B(pw.com)@/The main Perfect Writer edit program. (@b[P]erfect @b[W]riter@b[.COM]piled)

@b(pf.com)@/A program component of Perfect Writer
responsible for formatting. (@b[P]erfect @b[F]ormatter@b[.COM]piled)

@b(pp.com)@/A program component of Perfect Writer responsible for
guiding a formatted document through your Kaypro II printer.
(@b[P]erfect @b[P]rinter@b[.COM]piled)

@b(pf.dat)@/A file containing data about your Kaypro II
printer which Perfect Writer needs in order to format a document
properly. (@b[P]erfect @b[F]ormatter@b[.DAT]a)

@b(pw.hlp)@/A menu summarizing Perfect Writer's commands.
(@b[P]erfect @b[W]riter@b[.H]e@b[LP])
@end(description)

	To use the Edit Diskette as a working diskette which will
'boot up', or 'cold start', your Kaypro II computer, you must
copy to it your CP/M disk operating system using 'SYSGEN',  a
utility program included on your CP/M diskette.  The procedure
for doing this is described both in your Kaypro II User's Guide,
and the disk-based lesson 'B:KAYPRO.LRN'.

	Your Perfect Writer Edit Diskette will normally be inserted
in drive 'A' of your computer, while the blank, formatted diskette,
which will hold the document files you create, will be
placed in drive 'B'.

@b(The 'HELP' DIRECTORY)

	The file @b('pw.hlp'), which is located on the Perfect
Writer Edit Diskette, will present a screen listing of all
Perfect Writer commands. The file can be accessed at any time
during editing by typing the @b<HELP Command:

		Control--X    ?>

       (Use your shift key when typing the question mark.)

	Perfect Writer will split the screen and present the Help
Directory in the bottom window.    Directions for selecting any
particular group of commands are given at the top of the
Directory.   These are: type the Escape Key followed by the
number of the selection that you want.  Follow this with 'Escape.
. .V'.

	Perfect Writer will display the commands which you
request--e.g. 'Cursor Commands', 'Deletion Commands', etc.

	To return to the original menu of the Help Directory
type 'Escape. . .9' followed by 'Escape. . .Z'.

	To erase the Help Directory from the screen, type the ONE
WINDOW Command:  Control--X  1.

@flushleft[@b(2. Installation Diskette)]

	The Installation Diskette contains  a number of program
files used for various installation procedures, such as altering
certain 'Default Style Parameters', changing the function of
command keys, and  configuring a printer to Perfect Writer.  
Also, it contains the program files which define Perfect Filer's
'Organizational Data Base' and which must be transferred to their
own diskette (See p. 14 below). The Perfect Writer installation
files are:
@Begin(description)
@B(pfconfig.com)@/A configuration program used for defining 
your printer to Perfect Writer, and for creating or
modifying 'Default Style Parameters'.  (The use of this program
is discussed in Appendix 'A' of the Perfect Writer User's Guide.)
(@b[P]erfect @b[F]ormatter @b[CONFIG]uration@b[.COM]piled)

@B(pf.dat)@/The data file which holds technical information about
your printer that is needed by Perfect Writer. This file is
created by 'pfconfig.com', and must always be present on the
Perfect Writer Edit Diskette. (@b[P]erfect @b[F]ormatter@b[.DAT]a)


@B(pw.swp)@/This is an extra copy of the data file holding
'Virtual Memory' space, and certain technical data about the
Kaypro II terminal needed by Perfect Writer.  (Since Perfect
Writer comes pre-configured to the Kaypro II, a copy of this file
is already present on the Perfect Writer Edit diskette.)
(@b[P]erfect @b[W]riter@b[.SW]a@b[P])

@B(pwbind.com, functs.txt, pw.sym)@/Three files used for changing
 command key functions.  Their use is described in Appendix 'C'
of the Perfect Writer User's Guide.
@End(description)




	You will use the file programs on this Installation
Diskette to configure your printer to Perfect Writer.  Thereafter
you will probably use them very little, if at all.

	Perfect Writer comes preconfigured for a standard,
'no-frills' printer called 'Vanilla'.  This is not an actual
printer, but simply a printer 'definition'.  Using this
definition Perfect Writer will output to almost @i(any) printer
it comes across.  The text will be clean, orderly,
justified--what you might expect.  However, the 'Vanilla'
definition will not permit any fancy capabilities which your
particular printer may be capable of, such as boldfacing,
underlining, italics, etc.  To achieve these you must define your
printer to Perfect Writer, using the configuration program
'pfconfig.com'.   The 'pfconfig' program will in turn create a new
'pf.dat' file, holding the technical data about your printer
which Perfect Writer needs.  This 'pf.dat' file must then be
placed upon the Perfect Writer Edit Diskette.

	You will notice that the Edit Diskette already contains a
copy of the 'pf.dat' file. This file holds the 'vanilla'
configuration which can be used until you replace it with a new
'pf.dat' holding the proper specification for your printer.   
 
	The other most common application of these files is
changing the 'Default Style Parameters', which determine the
style of printed output--i.e. margins, distance between
paragraphs, paragraph indentions, etc.  This is also done during
configuration using  'pfconfig.com', with the resulting
specifications being stored in the same 'pf.dat' file.   Complete
instructions for using 'pfconfig.com' to perform both of these
operations  are described in Appendix A of the Perfect Writer
User's Guide.

@flushleft(@b[Missing 'PWCONFIG' Program?])

	Appendix A of your Perfect Writer User's guide refers to
a configuration program called 'pwconfig.com', which is used to
configure Perfect Writer to the particular computer which is
being used.  The special file called 'pw.swp', which holds
technical data about your computer, is actually created by the
configuration program 'pwconfig.com'.  

	Since Perfect Writer comes preconfigured to your Kaypro
II, this special file has not been included on the Installation
Diskette, since  it is simply not needed in cases where Perfect
Writer has been preconfigured.  Only the necessary 'pw.swp' file
has been provided.

@flushleft(@b['Organizational Data Base'])

	The remaining files to be found on the Installation
Diskette are the program files which define Perfect Filer's
'Organizational Data Base'.  These are discussed in the section
dealing with Perfect Filer (see p. 14-17 below).	

@flushleft(@b<Lessons Diskette>)

The Lessons Diskette contains several 'disk-based' lesson sets
which allow you to learn how to use Perfect Writer while working
at your Kaypro II computer.


To use these lessons:
@begin(itemize)

 place the @b<Lessons Diskette> in drive @B('B') and the Perfect Writer
@b<Edit Diskette> in drive @B(A).

Transfer, or 'log', to drive 'B' and initialize the Lessons
Diskette. That is:
@display[A>@b{b:  <carriage return>} (logs you to drive 'B')
B> @b{Control---C}   (initializes the disk on drive 'B')
B>@b{a: <carriage return>}  (logs you back to drive 'A')]

On drive 'A'  type:
@blankspace(2 lines)
                 @b{A>menu   <carriage return>}
@blankspace(2 lines)
	After some disk activity the Perfect Writer 'Main Menu'
will appear, presenting a list of editing activities which you
may perform using Perfect Writer.

  From this menu select "E--Edit a document".
Perfect Writer will ask for the name of the file to edit.  

	Type the file name @b('B:KAYPRO.LRN') (the 'B:' specifies
the drive on which the file is located).  This first disk based
lesson will provide you with an introduction to your Kaypro II
CP/M operating system.  @b(This is very important information,
which you  should take time to become familiar with.)
@blankspace(1 lines)
	After you have completed this lesson you will want to
begin the consecutive lessons which demonstrate the use of 
Perfect Writer' editing  commands.  Begin  with the file
"B:LESSON0" (i.e. Lesson{zero}).  
@end(itemize)

	The lessons will lead you step-by-step through all of
Perfect Writer's command routines.   Much of what may have seemed
difficult or strange at the beginning will appear familiar and
common place by the time you finish.

	One lesson represents an advanced introduction to the
Perfect Writer word processor.  The file name is 'B:ADVINTRO'. 
If you have  used a word processor before, then you may want to
begin with this lesson.  This lesson will also provide a useful
review/summary after you have completed the introductory lessons.

  	  The Lessons Diskette also contains several sample text
files that are used in connection with the Document Design
Lessons of Chapter XIX (19) in your Perfect Writer User's Guide. 
These text files illustrate certain formatting routines which you
will want to learn.  Instructions for displaying these text files
are provided in that chapter.
@string(head="Perfect Speller")
@newpage

@heading(@b{PERFECT SPELLER})

	Perfect Speller is the program that checks the spelling
of the documents which you create with Perfect Writer.  Although
it is located on its own diskette, it has been packaged with some
of the same program files contained on your Perfect Writer Edit
Diskette.  The files are:


@begin(description)
@B(pw.swp)@/The file containing the 'Virtual Memory' space and
certain technical data about your Kaypro II computer which
Perfect Writer needs to function properly.

@B(menu.com)@/The menu program which will guide you in using
Perfect Writer & Perfect Speller.

@B(pw.com)@/The main Perfect Writer edit program.

@B(ps.com)@/The Perfect Speller program. (@b[P]erfect
@b[S]peller@b[.COM]piled)

@B(dictnary.spl)@/The dictionary file which Perfect Speller uses
to verify the correct spelling of words.
(@b[DICT]io@b[NARY.SP]e@b[L]ler)

@B(affixtab.spl)@/A table of prefixes and suffixes which Perfect
Speller uses to check spelling. (@b[AFFIX TAB]les@b[.SP]e@b[L]ler)
@end(description)

	Because the Perfect Speller diskette contains the main
Perfect Writer editing program and Main Menu, it is possible to
use the Speller diskette not only to check the spelling of
documents, but also to create the documents themselves.  Simply
place the Perfect Speller diskette in drive 'A' and the diskette
to hold the file to be created and 'spelled' in  drive 'B'  (just
as with Perfect Writer).  

	As with the main Perfect Writer Edit diskette you will
want to install the CP/M disk operating system onto the Perfect
Speller diskette, using SYSGEN, thus allowing it to 'boot up', or
'cold start' your computer.

	 To format and print your documents, you will have to
replace the Speller Diskette with your main Perfect Writer Edit
diskette, containing the program files 'pf.com', 'pp.com' and
'pf.dat', all of  which govern formatting and printing
operations.

	Of course, if you are not so concerned about spelling,
you may want  to use the Perfect Writer Edit diskette as your
regular editing diskette, using Perfect Speller only occasionally
to check the spelling of a file.

	@b(Note:)  Switching Perfect Writer and Perfect Speller
diskettes should @b(only) be done when the CP/M command prompt (
'A>') is being displayed to the screen.  The newly inserted
diskette must be initialized (either using 'Control--C' or by
'resetting' the computer).  

	Thus, when Perfect Speller asks you 'Do you wish to exit
directly to Perfect Writer?', you should @b(NOT) replace the Perfect
Speller diskette, since the Perfect Writer command file 'pw.com'
is also located on the Perfect Speller diskette.  If you do
attempt to switch diskettes when this message appears, you will
get error messages and data loss.  

@string(head="Perfect Calc")
@newpage





@flushleft(@b<PERFECT CALC>)

	The Perfect Calc program, the Perfect Software program
which represents the most significant advance in spreadsheet
calculating power since the first electronic spreadsheet
appeared, comes to you on two diskettes:  A main program diskette
containing the Perfect Calc command files, and a Lessons Diskette
containing a set of eight disk-based lessons which will acquaint
you with Perfect Calc's commands while working at your Kaypro II
computer@b(*).  Also included on this last diskette are a number of
'application files'--sample spreadsheets to demonstrate the
variety of ways Perfect Calc can be used.

@b(*) If you did not receive a separate Perfect Calc Lessons
Diskette, first see if your dealer or KayPro User Group has a
copy.  If not, send $5 in check or money order OR a blank,
formatted diskette with prepaid return mailer to: Perfect
Software, Product Science Center, P.O. Box 1479, Eugene, Oregon 
97440.

@flushleft(@b[1. Perfect Calc Program Diskette])

	Perfect Calc's four main program files are:
@begin(description)

@B(pc.com)@/The main command file of Perfect Calc. (@b[P]erfect
@b[C]alc@b[.COM]piled)

@B(pc.ovl)@/An 'overlay' file which 'overlays' Perfect Calc command
routines back and forth between machine memory and disk storage.
(@b[P]erfect @b[C]alc@b[.OV]er@b[L]ay)

@b(pc.swp)@/A program file holding disk storage space for those
portions of your spreadsheet files which cannot be held in
machine memory. (@b[P]erfect @b[C]alc@b[.SW]a@b[P])

@B(pcconfig.com)@/A configuration program for installing Perfect
Calc.  Note:  Unlike Perfect Writer, Perfect Calc does not need
to be configured to your printer, since it uses the standard CP/M 
printer definition. However, you may wish to use this
configuration program to customize  printer output--i.e. changing
pitch or page widths  (See Appendix 'A' of the Perfect Calc User's
Guide). (@b[P]erfect @b[C]alc@b[.CONFIG]uration@b[.COM]piled)
@end(description)


	The only modification you will need to make to the Perfect
Calc Program Diskette is to install your CP/M disk operating system on
it, using the 'SYSGEN' utility provided on your CP/M diskette. 
This will allow it to 'boot up' or 'cold start' your computer.
The procedure for doing this is described in your Kaypro II
User's Guide, and the disk-based lesson 'B:KAYPRO.LRN'.


	Like Perfect Writer, the Perfect Calc Program Diskette should
be inserted in drive 'A' and a blank diskette to hold the
spreadsheet files you will create in drive 'B'.   As always, the
diskette in drive 'B' must be separately 'initialized' by
transferring to that drive and typing 'Control--C'.

@flushleft(@b[2. Perfect Calc Lessons Diskette])

	The Lessons Diskette contains a series of eight
sequential and interconnected lessons, which will acquaint you
with the command routines used by Perfect Calc.  Since many of
these commands follow Perfect Writer, they will be familiar to
you already.  To use these lessons:
@begin(itemize)

 Place the @b<Lessons Diskette> in drive '@b(B)' and the Perfect
Calc @b<Program Diskette> in drive '@b(A)'.

Transfer, or 'log', to drive 'B' and initialize the Lessons
Diskette.  That is, type:
@display[A>@b{b: <cr>} (logs you to drive 'B')
B> @b{Control---C}   (initializes the disk on drive 'B')
B>@b{a: <cr>} (logs you back to drive 'A')]

On drive 'A' type:
@blankspace(2 lines)
@center(A>@b{pc b:teachme.pc  <carriage return>})
@blankspace(2 lines)
{Note that 'b:' specifies that 'teachme.pc' is on drive 'B.'}
@end(itemize)
	
	The first lesson of Perfect Calc will be displayed on the
screen.  From then on, instructions will be provided to guide
you through the remaining lessons.

@flushleft{@b(Sample Spreadsheets)}

	The Lessons Diskette also contains a number of
'application packages', i.e. preconfigured, sample spreadsheets
which  demonstrate the variety of ways you can use Perfect Calc. 
These sample spreadsheets are intended as examples only, and
before using any of them you may wish to verify their correctness
and suitability for your particular needs. Instructions for
accessing each of these spreadsheets is provided in the Perfect
Calc User's Guide.
@newpage
@string(head="Perfect Filer")



@heading(@b{PERFECT FILER})

 
	Perfect Filer is the  powerful, yet simple-to-use
software product that will satisfy all of your records management
needs. The program is set up  and ready to use as a mailing list
system.  Of course, as you become familiar with all its power you
will want to use it for a variety of other applications.  Perfect
Filer is fully integrated with Perfect Writer and allows you to
merge information in its data bases with form letters, reports
and other documents.  


	Perfect Filer is  the program which involves the most
regrouping of program files before you can begin using the
system.  For technical reasons, as well as to conserve diskette
space, certain program files have been included together on the
same diskette.  They should be separated before you can begin
using the system.  The transfer of files is not a complicated
one, and you will be able to perform it in a very few minutes.

@flushleft(@b[The 'Organizational Data Base'])

	The first task is to remove Perfect Filer's
'Organizational Data Base' from Perfect Writer's Installation
Diskette.  These files are:

@begin(description)
@b(db.txt)@/The database 'text' file. (@b[D]ata@b[B]ase@b[.T]e@b[XT])

@b(database)@/The actual database.

@b(member.h)@/The member 'hashtable' key. (@b[MEMBER.H]ashtable)

@b(db.def)@/The database definition file. (@b[D]ata@b[B]ase@b[.DEF]inition)

@b(hashtab)@/The 'hashtable' used for sorting. (@b[HASHTAB]le)

@b(ss.sav)@/The file holding subset definitions. (@b[S]ub@b[SET]@b[.SAV]e)

@b(sslist.sav)@/The file holding defined subset lists. (@b[S]ub@b[S]et@b[LIST]s@b[.SAV]e)

@b(ssdesc.sav)@/The file holding subset descriptors.
(@b[S]ub@b[SET DESC]criptors@b[.SAV]e)

@b(listform.sav)@/The file holding defined list formats. (@b[LIST
FORM]at@b[.SAV]e)

@b(lformdsc.sav)@/The file holding list format descriptors.
(@b[L]ist @b[FORM]at @b[D]e@b[SC]riptor@b[.SAV]e)

@b(mailform.sav)@/The file holding the defined mail forms.
(@b[MAIL FORM.SAV]e)

@b(mformdsc.sav)@/The file holding mail form descriptors.
(@b[M]ail @b[FORM D]e@b[SC]riptor@b[.SAV]e)
@end(description)

	These files which define Perfect Filer's preconfigured
'Organizational Data Base' should be transferred from Perfect
Writer's Installation Diskette to a separate blank, formatted
diskette, using the CP/M utility 'PIP'.  The procedure for
copying individual files using 'PIP' is described in your Kaypro
II User's Guide, and the disk-based lesson 'B:KAYPRO.LRN'.  When
you have transferred these files label the new diskette holding
them: 'Organizational Data Base'.


	The  remaining Perfect Filer program files come to you on
a diskette labeled:

@flushleft[@b(Perfect Filer & Individual Data Base)]

	This diskette contains the main Filer program, plus the 
several sub-program files  required by that program.  Although
there is no special reason for knowing what these particular
files do, we have described them here for your information.  They are:
@begin(description)

@B(filer.com)@/Perfect Filer's main system program. (@b[FILER.COM]piled)

@B(create.com)@/The utility program used in creating the screen
configuration that defines a data base. (@b[CREATE.COM]piled)

@b(template.sav)@/A file containing the predefined templates
available to you when using 'create.com'.  (@[TEMPLATE.SAV]e)

@B(move.com)@/The utility used in moving data from one database
to another.

@b[terminal.def]@/The sub-program holding the technical data about
the Kaypro II computer which Perfect Filer needs to function
properly. (@b[TERMINAL.DEF]inition)

@b(accind)@/The program used to access individual records.
(@b[ACC]ess @b[IND]ividual)

@b(list)@/The sub-program used for printing lists and reports.

@b(mail)@/The sub-program used to generate mail.

@b(deflform)@/The sub-program used to define list formats.
(@b[DEF]ine @b[L]ist @b[FORM]at)

@b(setup)@/The sub-program used for 'setting up' Filer programs.

@b(defpform)@/The sub-program used for defining printer forms.
(@b[DEF]ine @b[P]rinter @b[FORM]s)

@b(defss)@/The sub-program used for defining subsets. (@b[DEF]ine
@b[S]ub@b[S]ets)
@end(description)


	Also included on this diskette are the program files
which define Perfect Filer's 'Individual Data Base', and which,
like the files which defined the 'Organizational Data Base' on the
Installation Diskette, will have to be copied to a diskette of
their own.   These files are  @b(identical) in name and number to those
listed above which define  the 'Organizational Data Base' with
the exception of three additional files, which are:

@begin(description)
@b(mailtest.mss)@/A test file used to illustrate the use of
Perfect Filer.

@b(label.txt)@/A file holding a label address specification.

@b(label2.txt)@/A second label address specification (used for
continuous envelopes).
@end(description)

	The diskette to which these files are copied should be
labeled 'Individual Data Base'.

	When you have finished shifting around the Perfect Filer
programs, you should have three diskettes in all.  The first
contains the main Filer programs, 'filer.com', 'create.com' and
'move.com', plus the several sub-programs which these main
programs require.

	The second and third diskettes contain the files which
define the 'Individual Data Base' and the 'Organizational Data
Base'. (These databases are placed on separate diskettes because
the technical operation of Perfect Filer requires that each
database occupy its own diskette. This requirement is explained
more fully in the Perfect Filer manual.)

@heading[@b(Place the  CP/M Operating System on Perfect Filer)]

	The only operation remaining with Perfect Filer is the
installation of the CP/M operating system onto the main program diskette
in order that it will 'boot up' or 'cold start' your computer. 
Do this using the CP/M utility 'SYSGEN', following the instructions
in your Kaypro II User's Guide, or the disk-based lesson 'B:KAYPRO.LRN'.

@heading[@b(Back-Up the New Perfect Filer Disks)]

	To save yourself possible time and trouble in the future,
you should 'back-up' the new Filer diskettes which you have just
prepared.  These will then be considered a second set of 'master'
diskettes to be used only for creating other 'working' Filer
diskettes.

	When using Perfect Filer, the diskette holding the main
Filer programs is inserted in disk drive 'A' where it will
'boot up' the computer.  The diskette holding the 'database' will
be inserted in disk drive 'B'.  (The database diskette will have
to be initialized separately ['reset' or 'Control--C'].)

@string(head="Conclusion")
@newpage



@heading[@b(REMOVE 'WRITE-PROTECT' TABS)]

	None of your Perfect Software @b(working) diskettes should be
'write-protected'. That is to say, some diskettes come with a
small  notch on the side of the diskette, which is used to signal
whether the disk can be written to, or whether the information it
contains is 'read/only' (R/O).  When this notch is covered with a
protective tab, the disk is considered to be 'write-protected',
and your CP/M disk operating system will  not allow any information
to be written to the diskette.

	All of the Perfect Software programs 'swap' data back and
forth to diskette as a part of their normal operation.  Should
the diskette be 'write-protected'  the programs will not be able
to function properly.

	Therefore, peel away all 'write-protect' tabs which may be
covering the small write-protect notch on the sides of both your
@b(working) diskettes and the diskettes which will hold the files
you create.

@newpage

@heading(@b{ALTERNATE COMMAND SET FOR KAYPRO II})

	Because of certain custom features presented by the
Kaypro II, two Perfect Writer commands have been slightly
altered.  In each the change is slight and will present no
problem to you. The commands are:
	
@flushleft(@b[The DELETE LINE Command])

	The Perfect Writer Manual lists this command as:

@center(Control---K)

	For the Kaypro II computer this command has been changed to:

@center(@b{Control---C})


@flushleft(@b[The REFRESH SCREEN Command])

	The Perfect Writer Manual lists this command as:

@center(Control---L)

	For the Kaypro II computer this command has been changed to:

@center(@b[Escape. . .Control---L])


	You may wish to mark these changes in your manuals and on
your reference cards.
@newpage
	CONCLUSION

	This concludes the procedures for setting up your Perfect
Software programs.  We are sure that you will find them a delight
to use.  


Happy computing. . . .


@center(@b[PERFECT SOFTWARE, INC.]
Product Science Center)COMMAND SET FOR KAYPRO II})

	Because o