10 PRINT CHR$(26)
20 PRINT">>>> MATCH calculates possible single-line impedance transformer <<<<"
30 PRINT"     between two complex impedances"
40 'Written by R. S. Stein, W6NBI - 6/22/84 - Based on article "Generalized
50 'Transmission Line Transformers" by T. Choinski, Microwave Journal, Dec 83.
60 'Corrected to change source impedance to conjugate, per correspondence
70 'with author, in line 270.
80 '7/24/84:  Modified to compute physical length of line
90 '12/20/84: Error traps added
100 PI=3.14159 : RAD=57.2958
110 PRINT STRING$(69,45)
120 INPUT"ENTERING IMPEDANCES IN RECTANGULAR OR POLAR FORM (R OR P)";Z$
130 PRINT 
140 IF Z$="R" OR Z$="r" GOTO 230
150 IF Z$<>"P" AND Z$<>"p" THEN GOSUB 620 : GOTO 120
160 PRINT"SOURCE IMPEDANCE"
170 INPUT"	MAGNITUDE = ";SM : INPUT"	PHASE ANGLE (DEG) = ";SP
180 PRINT"LOAD IMPEDANCE"
190 INPUT"	MAGNITUDE = ";LM : INPUT"	PHASE ANGLE (DEG) = ";LP
200 IF SM=LM AND (SP=-LP OR SP=-(LP-360)) GOTO 280
210 A=SM*COS(SP/RAD) : B=SM*SIN(SP/RAD) : C=LM*COS(LP/RAD) : D=LM*SIN(LP/RAD)
220 GOTO 310
230 PRINT"SOURCE IMPEDANCE"
240 INPUT"       R = ";A : INPUT "       X = ";B
250 PRINT"LOAD IMPEDANCE"
260 INPUT"       R = ";C : INPUT "       X = ";D
270 IF A<>C OR B<>-D GOTO 310
280 PRINT : PRINT"IMPEDANCES CAN BE MATCHED WITH A HALF-WAVELENGTH LINE OF ANY IMPEDANCE"
290 L=.5
300 GOTO 440
310 ON ERROR GOTO 570
320 B=-B
330 Z0=SQR(((A*(C^2+D^2))-(C*(A^2+B^2)))/(C-A))
340 'AS=source refl coeff angle (theta)   AL=load refl coeff angle (phi)
350 AS=ATN(2*B*Z0/((A-Z0)*(A+Z0)+B^2))
360 IF (A-Z0)*(A+Z0)+B^2<0 THEN AS=AS+PI
370 IF AS<0 THEN AS=AS+2*PI
380 AL=ATN(2*D*Z0/((C-Z0)*(C+Z0)+D^2))
390 IF (C-Z0)*(C+Z0)+D^2<0 THEN AL=AL+PI
400 IF AL<0 THEN AL=AL+2*PI
410 IF AL>AS THEN L=(AL-AS)/(4*PI) ELSE L=(2*PI+AL-AS)/(4*PI)
420 PRINT : PRINT USING"MATCHING LINE IMPEDANCE = ###.## OHMS";Z0
430 PRINT USING"MATCHING LINE LENGTH    =  #.### WAVELENGTH";L
440 PRINT 
450 INPUT "DO YOU WANT PHYSICAL LINE LENGTH (Y/N)";Q$
460 IF Q$<>"Y" AND Q$<>"y" GOTO 580
470 PRINT 
480 INPUT "FREQUENCY (MHz) = ";F
490 IF F=<0 THEN GOSUB 620 : GOTO 480
500 INPUT "VELOCITY OF PROPAGATION OF LINE (DECIMAL) = ";V
510 IF V=<0 OR V>1 THEN GOSUB 620 : GOTO 500
520 LL=L*V*11803/F
530 PRINT
540 PRINT USING"LINE LENGTH = ###.### INCHES";LL;
550 PRINT USING" = ###.## CM";LL*2.54
560 GOTO 580
570 PRINT : PRINT"IMPEDANCES CANNOT BE MATCHED WITH A SINGLE-LINE IMPEDANCE TRANSFORMER"
580 PRINT STRING$(69,45)
590 INPUT "RUN AGAIN (Y/N)";R$
600 IF R$="Y" OR R$="y" GOTO 10
610 END
620 'Error message
630 PRINT 
640 PRINT "IMPROPER ENTRY -- TRY AGAIN!"
650 PRINT 
660 RETURN
 OR R$="y" GOTO 10
610 END
620 'Err