/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO 
%DELETE $1.CRL 
*/
/*********************************************************************
*                               2UP                                  *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"
#DEFINE MAXW 132

CHAR doneflag,string[MAXLINE];
CHAR array[90][MAXW+2];
INT ncol,col,len,hold,margin,space,width;
INT bm,tm;

MAIN(argc,argv)

INT argc;
CHAR **argv;

  BEGIN
    INT i,j,k,firstflag;
    dioinit(&argc,argv);  	/* INITIALIZE DIO BUFFERS AND FLAGS */

/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

    INT ii,jj,optionerr;
    CHAR *ss;
    hold = ncol = space = margin = col = len = optionerr = 0;
    bm = tm = 0;
    FOR (ii=argc-1;ii>0;ii--)
    IF (argv[ii][0] == '-')
      THEN
	FOR (ss = &argv[ii][1]; *ss != '\0';)
	  LOOP
	    SWITCH (toupper(*ss++))
	      BEGIN
	      CASE 'L':
		len = atoi(ss);
		BREAK;
	      CASE 'C':
		col= atoi(ss);
		BREAK;
	      CASE 'M':
		margin = atoi(ss);
		BREAK;
	      CASE 'T':
		tm = atoi(ss);
		BREAK;
	      CASE 'B':
		bm = atoi(ss);
		BREAK;
	      CASE 'S':
		space = atoi(ss);
		BREAK;
	      CASE 'N':
		ncol= atoi(ss);
		BREAK;
	      CASE 'W':
		hold = TRUE;
		BREAK;
	      CASE 'H':
		optionerr = TRUE;
		BREAK;
	      DEFAULT:
		typef("2UP: Illegal option %c.\n"
		,*--ss);
		ss++;
		optionerr = TRUE;
		BREAK;
	      END
	    WHILE (isdigit(*ss)) ss++;
	  ENDLOOP
	FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
	argc--;
      ENDIF
    IF (optionerr) 
      THEN
	typef("2UP:   Legal options are:\n");
	typef("-Ln    Page length.\n");
	typef("-Cn    Column width .\n");
	typef("-Mn    Margin.\n");
	typef("-Tn    Top margin.\n");
	typef("-Bn    Bottom margin.\n");
	typef("-W     Wait at the bottom of each page.\n");
	typef("-Sn    Space between columns.\n");
	typef("-Nn    Number of columns.\n");
	exit(0);
      ENDIF
    IF (ncol == 0) ncol = 2;
    IF (space == 0) space = 0;
    IF (len == 0) len = 66;
    IF (col == 0) col = (80-margin-space*(ncol-1))/ncol;
    IF (len > 88) error("2UP: Too long a page, 88 lines is maximum.");
    IF ((margin+ncol*col+(ncol-1)*space) > MAXW) 
    error("2UP: Total width exceeds 132.");
    len = len-tm-bm;
    IF (len < 1)
    error("2UP: Insufficient length.");

/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
/*********************************/
/*	MAIN LOOP                */
/*********************************/
    firstflag = TRUE;
    doneflag = FALSE;
    width = margin + ncol*col + (ncol-1)*space;
    DO
      LOOP
	FOR (i=1;i<=len;i++)
	  LOOP
	    FOR(j=1;j<=MAXW+1;j++)
	    array[i][j] = ' ';
	  ENDLOOP
	FOR (k=0;k<ncol;k++)
	  LOOP
	    FOR (i=1;i<=len;i++)
	      LOOP
		IF (!doneflag) 
		  THEN
		    doneflag = getstring(string);
		    IF (k == 0 
		    && i == 1&& doneflag) goto done;
		    IF (k == 0 
		    && i == 1 && hold && !firstflag)THEN
			typef("Hit return to continue.\n");
			WHILE (!BDOS(6,0xff));
		      ENDIF
		    firstflag = FALSE;
		    IF (!doneflag) 
		      THEN
			strmov(&array[i][margin+k*col+k*space+1],
			string,col);
		      ENDIF
		  ENDIF
	      ENDLOOP
	  ENDLOOP
	FOR (i=1;i<=tm;i++) puts("\n");
	FOR (i=1;i<=len;i++)
	  LOOP
	    FOR (j=MAXW+1;j>0;j--)
	    IF (array[i][j] != ' ' || j == 1)
	      THEN
		array[i][j+1] = 0;
		BREAK;
	      ENDIF
	    puts(&array[i][1]);
	    puts("\n");
	  ENDLOOP
	FOR (i=1;i<=bm;i++) puts("\n");
      ENDLOOP
    WHILE (doneflag == FALSE);
    done:
    dioflush();
  END

strmov(s1,s2,n)
CHAR *s1,*s2;
INT n;
  BEGIN
    INT i;
    CHAR c;
    FOR (i=1;i<=n;i++)
      LOOP
	c = *s2;
	s2++;
	IF ((c == 0) || (c == '\n')) 
	  THEN
	    FOR (i;i<=n;i++) s1++;
	    RETURN(0);
	  ENDIF
	*s1 = c;
	s1++;
      ENDLOOP
  END
