/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO  -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               MERGEM                               *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/

#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

INT string_compare();
INT nocase,reverse,pos,len;

MAIN(argc,argv)
CHAR **argv;
INT argc;

BEGIN
	
    dioinit(&argc,argv);
    
/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

nocase = reverse = pos = len = 0;

INT ii,jj,optionerr;
CHAR *ss;
	optionerr = 0;
	
	FOR (ii=argc-1;ii>0;ii--)
	    IF (argv[ii][0] == '-')
		BEGIN
		    FOR (ss = &argv[ii][1]; *ss != '\0';)
			BEGIN
			    SWITCH (toupper(*ss++))
				BEGIN
				    CASE 'L':
					len = atoi(ss);
					BREAK;
				    CASE 'U':
					nocase = 1;
					BREAK;
				    CASE 'R':
					reverse = 1;
					BREAK;
				    CASE 'C':
					pos = atoi(ss);
					BREAK;
				    CASE 'H':
					optionerr = TRUE;
					BREAK;
				    DEFAULT:
					typef("MERGEM: Illegal option %c.\n"
						,*--ss);
					ss++;
					optionerr = TRUE;
					BREAK;
				END
			    WHILE (isdigit(*ss)) ss++;
			END
		    FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
		    argc--;
		END

	IF (optionerr) 
	    BEGIN
		typef("MERGEM: Legal options are:\n");
		typef("-U     Upper case compares.\n");
		typef("-R     Reverse sort.\n");
		typef("-Cn    Column Position to begin compare.\n");
		typef("-Ln    Length of string to compare.\n");
		exit(0);
	    END
	    
    IF (len == 0) len = MAXLINE;
    IF (pos > 0) pos--;

/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
INT nfiles,j;
CHAR fname[100][MAXLINE];
    nfiles = 0;
    WHILE (!getstring(fname[nfiles]))
	BEGIN
	    fname[nfiles][strlen(fname[nfiles])-1] = 0;
	    nfiles++;
	END
    WHILE (nfiles > 2)
	BEGIN
	    FOR (j=0;j<nfiles-1;j+=2)
		BEGIN
		    mergefile(fname[j],fname[j+1],fname[j/2]);
		END
	    IF (j < nfiles)
		BEGIN
		    strcpy(fname[j/2],fname[j]);
		    nfiles = (j/2)+1;
		END
	    ELSE
		BEGIN
		    nfiles = (j/2);
		END
	END
    IF (nfiles == 2)
	mergeout(fname[0],fname[1]);
    IF (nfiles == 1)
	spitout(fname[0]);
    dioflush();
END

string_compare(s1,t1)
CHAR *s1,*t1;
BEGIN
    INT i;
    IF ((strlen(s1) <= pos) && (strlen(t1) <= pos)) RETURN 0;
    IF (strlen(s1)<=pos) 
	IF (!reverse) RETURN -1;
	ELSE RETURN 1;
    IF (strlen(t1)<=pos) 
	IF (!reverse) RETURN 1;
	ELSE RETURN -1;
    IF (nocase)
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (toupper(s1[i]) != toupper(t1[i])) 
		    IF (!reverse) RETURN toupper(s1[i])-toupper(t1[i]);
			ELSE RETURN toupper(t1[i])-toupper(s1[i]);
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
    ELSE
    BEGIN
	FOR (i=pos;i<pos+len;i++)
	    BEGIN
		IF (s1[i] != t1[i]) 
		    IF (!reverse) RETURN s1[i] - t1[i];
			ELSE RETURN t1[i]-s1[i];
		IF (s1[i] == '\0')  RETURN 0;
	    END
	RETURN 0;
    END
END

mergefiles(fname1,fname2,fname3)
CHAR *fname1,*fname2,*fname3;
BEGIN
CHAR s1[MAXLINE],s2[MAXLINE];
FILE fcb1,fcb2,fcb3;
INT flag;
    IF (fopen(fname1,fcb1) == ERROR)
	error("MERGEM: Unable to open file %s.",fname1);
    IF (fopen(fname2,fcb2) == ERROR)
	error("MERGEM: Unable to open file %s.",fname2);
    IF (fcreat("$MERGE$",fcb3) == ERROR)
	error("MERGEM: Unable to create file $MERGE$.");
    IF (!fgets(s2,fcb2)) goto file2eof;
getfile1:
    IF (!fgets(s1,fcb1)) goto file1eof;

mainloop:
    flag = string_compare(s1,s2);
	    
    IF (flag>0)
	BEGIN
	    fputs(s2,fcb3);
	    goto getfile2;
	END
    ELSE
	BEGIN
	    fputs(s1,fcb3);
	    goto getfile1;
	END
			
getfile2:
    IF (!fgets(s2,fcb2)) goto file2eof;
    goto mainloop;
	
file1eof:
    fclose(fcb1);
    DO
	fputs(s2,fcb3);
    WHILE (fgets(s2,fcb2));
    fclose(fcb2);
    goto done;
    
file2eof:
    fclose(fcb2);
    DO
	fputs(s1,fcb3);
    WHILE (fgets(s1,fcb1));
    fclose(fcb1);
    
done:    
    putc(0x1A,fcb3);
    fflush(fcb3);	
    fclose(fcb3);
    unlink(fname1);
    unlink(fname2);
    unlink(fname3);
    rename("$MERGE$",fname3);
    return;
END

mergeout(fname1,fname2)
CHAR *fname1,*fname2;
BEGIN
CHAR s1[MAXLINE],s2[MAXLINE];
FILE fcb1,fcb2;
INT flag;
    IF (fopen(fname1,fcb1) == ERROR)
	error("MERGEM: Unable to open file %s.",fname1);
    IF (fopen(fname2,fcb2) == ERROR)
	error("MERGEM: Unable to open file %s.",fname2);
    IF (!fgets(s2,fcb2)) goto file2eof;
getfile1:
    IF (!fgets(s1,fcb1)) goto file1eof;

mainloop:
    flag = string_compare(s1,s2);
	    
    IF (flag>0)
	BEGIN
	    puts(s2);
	    goto getfile2;
	END
    ELSE
	BEGIN
	    puts(s1);
	    goto getfile1;
	END
			
getfile2:
    IF (!fgets(s2,fcb2)) goto file2eof;
    goto mainloop;
	
file1eof:
    fclose(fcb1);
    DO
	puts(s2);
    WHILE (fgets(s2,fcb2));
    fclose(fcb2);
    goto done;
    
file2eof:
    fclose(fcb2);
    DO
	puts(s1);
    WHILE (fgets(s1,fcb1));
    fclose(fcb1);
    
done:    
    unlink(fname1);
    unlink(fname2);
    return;
END

spitout(fname1)
CHAR *fname1;
BEGIN
CHAR s1[MAXLINE];
FILE fcb1;
    IF (fopen(fname1,fcb1) == ERROR)
	error("MERGEM: Unable to open file %s.",fname1);
    WHILE (fgets(s1,fcb1)) puts(s1);
    fclose(fcb1);
    unlink(fname1);
    return;
END
