/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO WILDEXP -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                               PAGE                                 *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

MAIN(argc,argv)

INT argc;
CHAR **argv;

  BEGIN

    INT string_compare();
    INT length,numbering,hold,nohdr,margin;

    dioinit(&argc,argv);  	/* INITIALIZE DIO BUFFERS AND FLAGS */

/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/

    INT ii,jj,optionerr;
    CHAR *ss;
    optionerr = 0;
    hold = nohdr = numbering = FALSE;
    margin = 0;
    length = 66;

    FOR (ii=argc-1;ii>0;ii--)
    IF (argv[ii][0] == '-')
      THEN
	FOR (ss = &argv[ii][1]; *ss != '\0';)
	  LOOP
	    SWITCH (toupper(*ss++))
	      BEGIN
	      CASE 'W':
		hold = TRUE;
		BREAK;
	      CASE 'P':
		nohdr = TRUE;
		BREAK;
	      CASE 'M':
		margin = atoi(ss);
		BREAK;
	      CASE 'L':
		length = atoi(ss);
		BREAK;
	      CASE 'H':
		optionerr = TRUE;
		BREAK;
	      CASE 'N':
		numbering = TRUE;
		BREAK;
	      DEFAULT:
		typef("PAGE: Illegal option %c.\n"
		,*--ss);
		ss++;
		optionerr = TRUE;
		BREAK;
	      END
	    WHILE (isdigit(*ss)) ss++;
	  ENDLOOP
	FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
	argc--;
      ENDIF

    IF (optionerr) 
      THEN
	typef("PAGE: Legal options are:\n");
	typef("-Ln    Lines per page.\n");
	typef("-N     Number lines.\n");
	typef("-W     Wait for keyin before each page.\n");
	typef("-Mn    Set left margin n.\n");
	typef("-P     Plain header, no page numbering.\n");
	exit(0);
      ENDIF

    IF ((length-=6) <= 0) error("PAGE: Length must be at least 6");

/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/

    wildexp(&argc,&argv);
    qsort(&argv[1],argc-1,2,&string_compare);

    WHILE (--argc)
      LOOP
	filecopy(*++argv,length,numbering,hold,nohdr,margin);
      ENDLOOP
    IF (DIOIN) 
      THEN
	dicopy(length,numbering,hold,nohdr,margin);
      ENDIF
    dioflush();
  END

filecopy(fname,length,numbering,hold,nohdr,margin)
CHAR *fname;
INT length,numbering,hold,nohdr,margin;
  BEGIN
    FILE fcb;
    char string[MAXLINE];
    int lineno,pgn;
    IF (fopen(fname,fcb) == ERROR)
      THEN
	typef("PAGE: Unable to open file \'%s\'.\N",fname);
	return;
      ENDIF
    lineno = 0;
    pgn = 1;
    WHILE (fgets(string,fcb))
      LOOP
	IF (lineno%length == 0)
	  THEN
	    if (hold)
	      THEN
		typef("PAGE: File %s. Hit return to continue.\n",fname);
		WHILE (!BDOS(6,0xff));
	      ENDIF
	    IF (nohdr)
	      THEN
		printf("\n\n\n");
	      ENDIF
	    ELSE
	      THEN
		printf("\n");
		marg(margin);
		printf("Pg. %d   FILE: %s\n\n",pgn++,fname);
	      ENDIF
	  ENDIF
	marg(margin);
	IF (numbering)
	  THEN
	    printf("%7d ",lineno+1);
	  ENDIF
	xputs(string);
	lineno++;
	IF (lineno%length==0)
	  THEN
	    printf("\n\n\n");
	  ENDIF
      ENDLOOP
    IF (lineno%length !=0) 
      THEN
	WHILE (lineno++%length!=0) putchar('\n');
	printf("\n\n\n");
      ENDIF
    fclose(fcb);
  END

dicopy(length,numbering,hold,nohdr,margin)
INT length,numbering,hold,nohdr,margin;
  BEGIN
    int lineno,pgn;
    char string[MAXLINE];
    lineno = 0;
    pgn = 1;
    WHILE (!getstring(string))
      LOOP
	IF (lineno%length == 0)
	  THEN
	    if (hold)
	      THEN
		typef("PAGE: Hit return to continue.\n");
		WHILE (!BDOS(6,0xff));
	      ENDIF
	    IF (nohdr)
	      THEN
		printf("\n\n\n");
	      ENDIF
	    ELSE
	      THEN
		printf("\n");
		marg(margin);
		printf("Pg. %d\n\n",pgn++);
	      ENDIF
	  ENDIF
	marg(margin);
	IF (numbering)
	  THEN
	    printf("%7d ",lineno+1);
	  ENDIF
	xputs(string);
	lineno++;
	IF (lineno%length==0)
	  THEN
	    printf("\n\n\n");
	    IF (hold)
	      THEN
		typef("PAGE: Hit return to continue.\n");
		WHILE (!BDOS(6,0xff));
	      ENDIF
	  ENDIF
      ENDLOOP
    IF (lineno%length !=0) 
      THEN
	WHILE (lineno++%length!=0) putchar('\n');
	printf("\n\n\n");
      ENDIF
  END

INT string_compare(s,t)
CHAR **s, **t;
  BEGIN
    CHAR *s1, *t1;
    INT i;
    s1 = *s;
    t1 = *t;
    FOR (i=0;i<MAXLINE;i++)
      LOOP
	IF (t1[i] != s1[i]) 
	RETURN s1[i] - t1[i];
	IF (s1[i] == '\0') RETURN 0;
      ENDLOOP
    RETURN 0;
  END

xputs(string)
CHAR *string;
  BEGIN
    INT col,c;
    col = 1;
    WHILE (c=*string++)
      LOOP
	IF (c == '\t')
	DO
	putchar(' ');
	WHILE (++col%8 != 1);
	ELSE
	  THEN
	    putchar(c);
	    col++;
	  ENDIF
      ENDLOOP
  END

marg(n)
INT n;
  BEGIN
    INT i;
    FOR(i=1;i<=n;i++) putchar(' ');
  END
