/*
%CC1 $1.C -X -E5000
%CLINK $1 DIO  -S
%DELETE $1.CRL 
*/
/*********************************************************************
*                             SELECT                                 *
**********************************************************************
*                  COPYRIGHT 1983 EUGENE H. MALLORY                  *
*********************************************************************/
#INCLUDE "BDSCIO.H"
#INCLUDE "DIO.H"

#DEFINE AND &&
#DEFINE OR ||
#DEFINE EQUAL ==
#DEFINE NOTEQUAL !=
#DEFINE NOT !
#DEFINE found 0x80
#DEFINE notfound 0x81
#DEFINE match 0x82
#DEFINE notmatch 0x83
#DEFINE notbegin 0xFF
#DEFINE notend 0x8A
#DEFINE skipany 0x86
#DEFINE skipone 0x87
#DEFINE lineend 0x0A
#DEFINE linestart 0x7F
#DEFINE anyalpha 0x12
#DEFINE anynumber 0x14
          
CHAR string[MAXLINE+1];
CHAR pattern[MAXLINE+1];
INT i,j,exclude,afterflag,after,before,firstpat,nextpat,lino;
    
MAIN(argc,argv)
CHAR **argv;
INT argc;

BEGIN
    CHAR c;
	
    dioinit(&argc,argv);

/*********************************************************************
***               ARGUMENT PROCESSING                              ***
*********************************************************************/
    
firstpat = nextpat = lino = 0;
exclude = after = afterflag = before = FALSE;
    
INT ii,jj,optionerr;
CHAR *ss;
	optionerr = FALSE;
	
	FOR (ii=argc-1;ii>0;ii--)
	    IF (argv[ii][0] == '-')
		BEGIN
		    FOR (ss = &argv[ii][1]; *ss != '\0';)
			BEGIN
			    SWITCH (toupper(*ss++))
				BEGIN
				    CASE 'A':
					after = 1;
					BREAK;
				    CASE 'B':
					before = 1;
					BREAK;
				    CASE 'X':
					exclude = 1;
					BREAK;
				    CASE 'N':
					lino = 1;
					BREAK;
				    CASE 'H':
					optionerr = TRUE;
					BREAK;
				    DEFAULT:
					typef("SELECT: Illegal option %c.\n"
						,*--ss);
					ss++;
					optionerr = TRUE;
					BREAK;
				END
			    WHILE (isdigit(*ss)) ss++;
			END
		    FOR (jj=ii;jj<(argc-1);jj++) argv[jj] = argv[jj+1];
		    argc--;
		END
	

	IF (optionerr) 
	    BEGIN
		typef("SELECT: Legal options are:\n");
		typef("-X     Select lines without pattern.\n");
		typef("-N     Number selected lines.\n");
		typef("-A     Select lines after pattern is found.\n");
		typef("-B     Select lines before pattern is found.\n");
		typef("Meta characters are:.\n");
		typef("* - Any character string.\n");
		typef("? - Any single character.\n");
		typef("_ - A space.\n");
		typef("\\ - A literal character follows.\n");
		typef("{ - Beginning of line.\n");
		typef("} - End of line.\n");
		typef("@ - Any alphabetic character.\n");
		typef("# - Any numeric character.\n");
		typef("! - NOT the character that follows.\n");
		exit(0);
	    END
	    	
	    
    IF (exclude+after+before > 1) error("SELECT: Only one option allowed.");
    IF (argc != 2) error("SELECT: One pattern argument required.");
    
/*********************************************************************
***                  END OF ARGUMENT PROCESSING                    ***
*********************************************************************/
    
    setuppat(argv[1],pattern);
    
    WHILE (NOT(getstring(&string[1])))
	BEGIN
	    string[0] = linestart;
	    IF (find(0) EQUAL found OR afterflag)
		BEGIN
		    IF (!exclude)
			BEGIN
			    IF (after) afterflag = TRUE;
			    IF (before) GOTO done;
			    IF (lino) printf("%7d ",lino);
			    puts(&string[1]);
			END
		END
	    ELSE
		BEGIN
		    IF (exclude || before)
			BEGIN
			    IF (lino) printf("%7d ",lino);
			    puts(&string[1]);
			END
		END
	    IF (lino) lino++;
	END
done:
    dioflush();	
END

find(first)
INT first;
    BEGIN
	i=0;
	j=first;
	firstpat = first;
loop:
	SWITCH(search())
	    BEGIN
		CASE match:
		    IF (i  EQUAL 0) firstpat = j;
		    i++;
		    j++;
		    IF (pattern[i]  EQUAL 0)
			BEGIN
			    nextpat	= j;
			    IF (pattern[0] EQUAL notbegin)
				firstpat++;
			    IF (pattern[strlen(pattern)-1] EQUAL notend)
				nextpat--;
			    RETURN found;
			END
		    IF (string[j] EQUAL 0) RETURN notfound;
		    goto loop;
		    
		CASE notmatch:
		    firstpat++;
		    j = firstpat;
		    IF (string[j] EQUAL 0) RETURN notfound;
		    i = 0;
		    GOTO loop;
		    
		CASE found:
		    nextpat = j;
		    IF (pattern[0] EQUAL notbegin)
			firstpat++;
		    IF (pattern[strlen(pattern)-1] EQUAL notend)
			nextpat--;
		    RETURN found;
		    
		CASE notfound:
		    RETURN notfound;
	    END
END

search()
BEGIN
    INT c,isave;
    SWITCH (pattern[i])
    BEGIN
        CASE 0:
            RETURN found;
        CASE anyalpha:
            IF (isalpha(string[j]))
                    RETURN match;
            ELSE RETURN notmatch;
        CASE anynumber:
            IF (isdigit(string[j]))
                    RETURN match;
            ELSE RETURN notmatch;
        CASE anyalpha|0x80:
            IF (!isalpha(string[j])
               AND j NOTEQUAL 0
               AND string[j] NOTEQUAL lineend)
                   RETURN match;
            ELSE RETURN notmatch;
        CASE anynumber|0x80:
            IF (!isdigit(string[j])
               AND j NOTEQUAL 0
               AND string[j] NOTEQUAL lineend)
                   RETURN match;
            ELSE RETURN notmatch;
        CASE skipany:
            i++;
            IF (pattern[i] EQUAL 0)
                BEGIN
                    j = strlen(string);
                    RETURN found;
                END
            isave = i;
loop:       i = isave;
loop2:      SWITCH(search())
                BEGIN
                    CASE match:
                        i++;
                        IF (pattern[i] EQUAL 0)
                            BEGIN
                               i--;
                               RETURN match;
                            END
                        j++;
                        IF (string[j] EQUAL 0)
                            BEGIN
                               i--;
                               j--;
                               RETURN notfound;
                            END
                        GOTO loop2;
                    CASE notmatch:
                        j++;
                        IF (string[j] EQUAL 0)
			    BEGIN
				j--;
				RETURN notmatch;
			    END
                        GOTO loop;
                    CASE found:
                        RETURN found;
                    CASE notfound:
                        RETURN notfound;
                    END
        CASE skipone:
            IF (string[j] EQUAL '\n') RETURN notfound;
            IF (j EQUAL 0) RETURN notmatch;
            i++;
            j++;
            IF (string[j] EQUAL 0) return notfound;
                SWITCH(search())
                    BEGIN
                        CASE match:
                            RETURN match;
                        CASE notmatch:
                            j--;
                            RETURN notmatch;
                        CASE found:
                            RETURN found;
                        CASE notfound:
                            RETURN notfound;
                    END
        DEFAULT:
            c =  pattern[i];
            IF (c & 0x80)
                BEGIN
                IF ((c&0x7f) NOTEQUAL toupper(string[j])
                    AND j NOTEQUAL 0
                    AND string[j] NOTEQUAL lineend)
                    RETURN match;
                ELSE RETURN notmatch;
                END
            ELSE
                BEGIN
                IF (c EQUAL toupper(string[j]))
                    RETURN match;
                ELSE RETURN notmatch;
                END
    END
END

setuppat(pat,str)
CHAR *pat;
CHAR *str;
BEGIN
INT pi,c;
pi = 0;
WHILE (c = pat[pi++])
    BEGIN
	SWITCH (c)
	    BEGIN
		CASE '*':
		    *str++ =  skipany;
		    IF (pat[pi] EQUAL '!'
			&&
			pat[pi+1] EQUAL '}')
			    error("SELECT: *!} not allowed.");
		    BREAK;
		CASE '?':
		    *str++ = skipone;
		    BREAK;
		CASE '}':
		    *str++ = lineend;
		    IF (pat[pi] NOTEQUAL 0)
			error("SELECT: } must be last.");
		    BREAK;
		CASE '{':
		   *str++ = linestart;
		   IF (pi NOTEQUAL 1)
			error("SELECT: { must be first.");
		   BREAK;
		CASE '@':
		   *str++ = anyalpha;
		   BREAK;
		CASE '#':
		   *str++ = anynumber;
		   BREAK;
		CASE '_':
		    *str++ = ' ';
		    BREAK;
		CASE '\\':
		    c = pat[pi++];
		    IF (c EQUAL 0 OR c EQUAL '\n')
	error("SELECT: Bad pattern, \\ requires character following.");
		    *str++ = c;
		    BREAK;
		CASE '!':
		    c = pat[pi++];
		    IF (c < 0x20)
			error("SELECT: Bad pattern after !.");
		    SWITCH(c)
			BEGIN
			    CASE '*':
			    CASE '?':
			    CASE '!':
			    CASE 0:
			    error ("SELECT: Bad pattern after !.");
			    CASE '}':
				*str++ = notend;
				IF (pat[pi] NOTEQUAL 0)
				    error("SELECT: !} must be last.");
				IF (pi EQUAL 2)
				    error("SELECT: No pattern before !}.");
				BREAK;
			    CASE '{':
				*str++ = notbegin;
				IF (pi NOTEQUAL 2)
				    error("SELECT: !{ must be first.");
				IF (pat[pi] EQUAL 0)
				    error("SELECT: No pattern after !{.");
				IF (pat[pi] EQUAL '*')
				    error("SELECT: !{* not allowed.");
				IF (pat[pi] EQUAL '!'
				    &&
				    pat[pi+1] EQUAL '}')
				    error("SELECT: !{!} not allowed.");
				BREAK;
			    CASE '@':
				*str++ = anyalpha|0x80;
				BREAK;
			    CASE '#':
				*str++ = anynumber|0x80;
				BREAK;
			    CASE '_':
				*str++ = ' '|0x80;
				BREAK;
			    CASE '\\':
				c = pat[pi++];
				IF (c EQUAL 0 OR c EQUAL '\n' OR c < 0x20)
			    error("SELECT: Bad pattern after !\\.");
				*str++ = c|0x80;
				BREAK;
			    DEFAULT:
				*str++ = c|0x80;
			END
		    BREAK;
	       DEFAULT:
		   *str++ = c;
	    END
    END
    *str = 0;
END
