*
*  MODIFICATION FOR DYNAMIC NON-PAGING/PAGING FOR TYPE109.
*
*  Inserting the following modification into TYPE109.COM will allow
*  it to page, or not, depending on the command line option used.
*  With this modification, the syntax for use is:
*
*		TYPE109A FILENAME.1 [...FILENAME.N] P
*
*  which will inhibit paging, or
*
*		TYPE109A FILENAME.1 [...FILENAME.N]
*
*  which will page as usual.  (This scheme assumes that location 103h,
*  is non-zero, and paging is therefore enabled.  If location 103h does
*  contain zero, use of the 'P' option will have no effect.)
*
*  To install this modification:
*
*	1.  Rename this file to TYPE109A.ASM
*	2.  Assemble this file using ASM or MAC.
*	3.  DDT TYPE109.COM
*	4.  ITYPE109A.HEX
*	5.  R
*	6.  G0
*	7.  SAVE 8 TYPE109A.COM
*
*
*				  Ken Lovett
*				  November 25, 1983
*
	org	0100h
	jmp	begin
;
	org	0177h
	db	0dh
	db	'TYPE 1.09a: '
;
	org	0280h
	db	'11/25/83'
;
	org	0445h
	db	'TYPE ABORTED: Maximum lines exceeded.'
	db	0ah,0dh
	db	'Please use XMODEM.'
	db	0ah,0dh
	db	00h
	jmp	0365h
begin
	lda	0103h		; get customized lines/screen
	sta	lines		; initialize in case of re-entry
	lxi	h,0080h 	; point to command line char count
	mov	e,m		; get count
	mvi	d,0
	dad	d		; add it to beginning of command line
	mov	a,m		; get last char of command line
	cpi	'P'		; 'P' for page-off?
	jnz	skipit		; no, skip it
	dcx	h
	mov	a,m
	cpi	' '		; preceded by space?
	jnz	skipit		; no, skip it
	xra	a		; yes, turn off paging
	sta	lines
skipit
	jmp	0166h
;
lines	db	00h
;
	org	04b1h
	lda	lines
	end

, skip it
	xra	a		; yes, turn off paging
	sta	lines